//
//  AppDelegate.m
//  Three20Test1
//
//  Created by maxfong on 12-5-21.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"
#import "RootViewController.h"
#import "StyleController.h"
#import "ScrollController.h"
#import "TableController.h"

@implementation AppDelegate

@synthesize window = _window;

- (void)dealloc
{
    [_window release];
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(UIApplication *)application
{
    TTNavigator *navigator = [TTNavigator navigator];
    navigator.persistenceMode = TTNavigatorPersistenceModeAll;
    navigator.window = [[[UIWindow alloc] initWithFrame:TTScreenBounds()] autorelease];
    
    TTURLMap *map = navigator.URLMap;
    
    [map from:@"*" toViewController:[TTWebController class]];
    
    [map from:@"tt://rootView" toSharedViewController:[RootViewController class]];
    
    [map from:@"tt://style" toViewController:[StyleController class]];
    [map from:@"tt://scroll" toViewController:[ScrollController class]];
    [map from:@"tt://table" toViewController:[TableController class]];
    
    
    if (![navigator restoreViewControllers]) {
        [navigator openURLAction:[TTURLAction actionWithURLPath:@"tt://rootView"]];
    }
}

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url
{
    [[TTNavigator navigator] openURLAction:[TTURLAction actionWithURLPath:url.absoluteString]];
    return YES;
}
@end
