//
//  ScrollController.m
//  Three20Test1
//
//  Created by maxfong on 12-5-21.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//
#import "ScrollController.h"
#import "Styles.h"

@implementation ScrollController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        [TTStyleSheet setGlobalStyleSheet:[[[Styles alloc] init] autorelease]];
        colors = [[NSArray arrayWithObjects:[UIColor colorWithWhite:0.9 alpha:1],
                  [UIColor blueColor],
                  [UIColor grayColor], nil] retain];
        self.title = @"Scroll";
    }
    return self;
}
- (void)loadView
{
    CGRect appFrame = [UIScreen mainScreen].applicationFrame;
    CGRect frame = CGRectMake(0, 0, appFrame.size.width, appFrame.size.height -44);
    self.view = [[[UIView alloc] initWithFrame:frame] autorelease];

    pageControl = [[TTPageControl alloc] initWithFrame:CGRectMake(0, 0, self.view.width, 20)];
    pageControl.autoresizingMask = UIViewAutoresizingFlexibleWidth;
    pageControl.backgroundColor = [UIColor colorWithWhite:0.9 alpha:1];
    pageControl.currentPage = 0;
    pageControl.numberOfPages = [colors count];
    [pageControl addTarget:self action:@selector(changePage:) forControlEvents:UIControlEventValueChanged];
    [self.view addSubview:pageControl];
    
    scrollView = [[TTScrollView alloc] initWithFrame:CGRectMake(0, pageControl.bottom, self.view.bounds.size.width, 350)];
    scrollView.autoresizingMask = UIViewAutoresizingFlexibleWidth;
    scrollView.dataSource = self;
    scrollView.delegate = self;
    scrollView.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:scrollView];
}

- (void)changePage:(id)sender
{
    int page = pageControl.currentPage;
    [scrollView setCenterPageIndex:page];
}

#pragma make - ScrollView dataSource
- (NSInteger)numberOfPagesInScrollView:(TTScrollView *)scrollView
{
    return [colors count];
}
- (UIView *)scrollView:(TTScrollView *)scrollView pageAtIndex:(NSInteger)pageIndex
{
    TTView *pageView = nil;
    if (!pageView) {
        pageView = [[[TTView alloc] init] autorelease];
        pageView.backgroundColor = [UIColor clearColor];
        //pageView.userInteractionEnabled = NO;
    }
    pageView.style =
    [TTShapeStyle styleWithShape:[TTRoundedRectangleShape shapeWithRadius:30] next:
    [TTInsetStyle styleWithInset:UIEdgeInsetsMake(10, 10, 10, 10) next:
    [TTLinearGradientFillStyle styleWithColor1:[colors objectAtIndex:pageIndex]
                                          color2:[UIColor whiteColor] next:
    [TTSolidBorderStyle styleWithColor:[UIColor blueColor] width:1 next:
    nil]]]];
    
    int height = 20;
    if (pageIndex ==0) {
        NSArray* buttons = [NSArray arrayWithObjects:
                            [TTButton buttonWithStyle:@"toolbarBackButton:" title:@"Back Button"],
                            [TTButton buttonWithStyle:@"blackForwardButton:" title:@"Black Button"],
                            [TTButton buttonWithStyle:@"dropButton:" title:@"Shadow Button"],
                            nil];
        for (TTButton* button in buttons) {
            button.font = [UIFont boldSystemFontOfSize:12];
            button.frame = CGRectMake(80, height, 100, 30);
            [button sizeToFit];
            [pageView addSubview:button];
            height += 50;
        }
    }else if(pageIndex==1){
        NSArray* styles = [NSArray arrayWithObjects:
                        //1
                        [TTSolidFillStyle styleWithColor:[UIColor whiteColor] next:
                        [TTSolidBorderStyle styleWithColor:[UIColor blackColor] width:1 next:nil]],
                        //2
                        [TTShapeStyle styleWithShape:[TTRoundedRectangleShape shapeWithRadius:10] next:
                        [TTSolidFillStyle styleWithColor:[UIColor whiteColor] next:
                            [TTLinearGradientBorderStyle styleWithColor1:RGBCOLOR(0, 0, 0)
                                                                  color2:RGBCOLOR(216, 221, 231) width:2 next:nil]]],
                        //3
                        [TTShapeStyle styleWithShape:[TTRoundedRectangleShape shapeWithRadius:10] next:
                        [TTSolidFillStyle styleWithColor:[UIColor whiteColor] next:
                        [TTInnerShadowStyle styleWithColor:RGBACOLOR(0,0,0,0.5) blur:6 offset:CGSizeMake(1, 1) next:
                        [TTSolidBorderStyle styleWithColor:[UIColor blackColor] width:1 next:nil]]]],
                        //4
                        [TTShapeStyle styleWithShape:[TTRoundedRectangleShape shapeWithRadius:10] next:
                        [TTShadowStyle styleWithColor:RGBACOLOR(255,255,255,0.9) blur:1 offset:CGSizeMake(0, 1) next:
                        [TTLinearGradientFillStyle styleWithColor1:RGBCOLOR(255, 255, 255)
                                                            color2:RGBCOLOR(216, 221, 231) next:
                        [TTSolidBorderStyle styleWithColor:[UIColor blueColor] width:1 next:nil]]]],
                        nil];
        for (TTStyle *style in styles) {
            CGRect frame = CGRectMake(80, height, 100, 30);
            TTView *view = [[[TTView alloc] initWithFrame:frame] autorelease];
            view.backgroundColor = pageView.backgroundColor;
            view.style = style;
            [pageView addSubview:view];
            height+=50;
        }
        
    }else if(pageIndex==2){
        pageView.frame = CGRectMake(10, 10, 300, 380);
        TTTabBar *tab1 = [[TTTabStrip alloc] initWithFrame:CGRectMake(20, 40, 260, 41)];
        tab1.tabItems = [NSArray arrayWithObjects:
                         [[[TTTabItem alloc] initWithTitle:@"Tab1"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"Tab2"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"Tab3"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"Tab4"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"Tab5"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"Tab6"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"Tab7"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"Tab8"] autorelease],
                         nil];
        [pageView addSubview:tab1];
        TTTabBar *tab2 = [[TTTabBar alloc] initWithFrame:CGRectMake(20, tab1.bottom, 230, 40)];
        tab2.tabItems = [NSArray arrayWithObjects:
                         [[[TTTabItem alloc] initWithTitle:@"one"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"two"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"three"] autorelease],
                         [[[TTTabItem alloc] initWithTitle:@"four"] autorelease],
                         nil];
        tab2.selectedTabIndex = 3;
        [pageView addSubview:tab2];
        TTTabItem *item = [tab2.tabItems objectAtIndex:3];
        item.badgeNumber = 10;
    }
    
    return pageView;
}
- (CGSize)scrollView:(TTScrollView *)scrollView sizeOfPageAtIndex:(NSInteger)pageIndex
{
    return CGSizeMake(320, 416);
}

#pragma make - ScrollView delegate
- (void)scrollView:(TTScrollView *)scrollView didMoveToPageAtIndex:(NSInteger)pageIndex
{
    pageControl.currentPage = pageIndex;
}

- (void)dealloc {
    scrollView.delegate = nil;
    scrollView.dataSource = nil;
    TT_RELEASE_SAFELY(scrollView);
    TT_RELEASE_SAFELY(pageControl);
    TT_RELEASE_SAFELY(colors);
    [super dealloc];
}
@end
