//
//  StyleController.m
//  Three20Test1
//
//  Created by maxfong on 12-5-21.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import "StyleController.h"
#import "Styles.h"

@implementation StyleController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    if (self=[ super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        [TTStyleSheet setGlobalStyleSheet:[[[Styles alloc] init] autorelease]];
        [[TTNavigator navigator].URLMap from:@"tt://compose" toModalViewController:self selector:@selector(composeTo:)];
        [[TTNavigator navigator].URLMap from:@"tt://post" toViewController:self selector:@selector(post:)];
        
        self.title = @"Style";
        self.navigationItem.title = @"Style1";
    }
    return self;
}

- (UIViewController *)composeTo:(NSString *)str
{
    TTMessageController *controller = [[[TTMessageController alloc] init] autorelease];
    return controller;
}
- (UIViewController *)post:(NSDictionary *)query
{
    TTPostController *controller = [[[TTPostController alloc] init] autorelease];
    return controller;
}

- (void)loadView
{
    CGRect appFrame = [UIScreen mainScreen].applicationFrame;
    self.view = [[[UIView alloc] initWithFrame:appFrame] autorelease];
    self.view.backgroundColor = [UIColor colorWithWhite:0.9 alpha:1];
    
    self.navigationItem.rightBarButtonItem = [[[UIBarButtonItem alloc] initWithTitle:@"TTMessage" style:UIBarButtonItemStyleBordered target:@"tt://compose" action:@selector(openURLFromButton:)] autorelease];
    self.navigationItem.leftBarButtonItem = [[[UIBarButtonItem alloc] initWithTitle:@"TTPost" style:UIBarButtonItemStyleBordered target:@"tt://post" action:@selector(openURLFromButton:)] autorelease];
    
    NSString *Text = @"This is <b>Text</b>, <i>Look:</i><span class=\"blueText\">bule</span>;";
    TTStyledTextLabel *label = [[[TTStyledTextLabel alloc] initWithFrame:CGRectMake(50.0, 100.0, 200.0, 100.0)] autorelease];
    label.text = [TTStyledText textFromXHTML:Text lineBreaks:YES URLs:YES];
    label.backgroundColor = [UIColor colorWithWhite:0.9 alpha:1];
    [self.view addSubview:label];
}
- (void)viewDidLoad
{
    UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectMake(20.0, 20.0, 48.0, 48.0)];
    UIImage *image = [UIImage imageNamed:@"China.gif"];    
    imageView.image = image;
    [self.view addSubview:imageView];
}
- (void)dealloc
{
    [[TTNavigator navigator].URLMap removeURL:@"tt://compose"];
    [[TTNavigator navigator].URLMap removeURL:@"tt://post"];
    [super dealloc];
}
@end
